'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _jsxFileName='src/containers/IssuesList/EnhancedIssuesListItem.js';var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};var _lodash=require('lodash');var _react=require('react');var _react2=_interopRequireDefault(_react);var _reactApollo=require('react-apollo');var _recompose=require('recompose');var _IssuesListItem=require('../../components/IssuesListItem');var _IssuesListItem2=_interopRequireDefault(_IssuesListItem);var _connect=require('../../enhancers/connect');var _connect2=_interopRequireDefault(_connect);var _withIssuesListQueryVariables=require('../../enhancers/withIssuesListQueryVariables');var _withIssuesListQueryVariables2=_interopRequireDefault(_withIssuesListQueryVariables);var _IssueUpvoteCreate=require('../../graphql/mutations/IssueUpvoteCreate');var _IssueUpvoteCreate2=_interopRequireDefault(_IssueUpvoteCreate);var _IssueUpvoteDelete=require('../../graphql/mutations/IssueUpvoteDelete');var _IssueUpvoteDelete2=_interopRequireDefault(_IssueUpvoteDelete);var _IssuesList=require('../../graphql/queries/IssuesList');var _IssuesList2=_interopRequireDefault(_IssuesList);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}var optimisticResponseId=-1;var createIssueUpvoteOptimisticResponse={createIssueUpvote:{id:optimisticResponseId,__typename:'IssueUpvote'},__typename:'Mutation'};var deleteIssueUpvoteOptimisticResponse={deleteIssueUpvote:{id:optimisticResponseId,__typename:'IssueUpvote'},__typename:'Mutation'};var enhance=(0,_recompose.compose)((0,_recompose.setDisplayName)('EnhancedIssuesListItem'),(0,_connect2.default)(function(state){var _ref;return{endUserId:(_ref=state.endUser)!=null?_ref.userId:_ref};}),(0,_withIssuesListQueryVariables2.default)({queryVariablesPropName:'issuesListQueryVariables',loadingPropName:'issuesListQueryVariablesLoading'}),(0,_recompose.branch)(function(_ref3){var issuesListQueryVariablesLoading=_ref3.issuesListQueryVariablesLoading;return issuesListQueryVariablesLoading;},_recompose.renderNothing),(0,_reactApollo.graphql)(_IssueUpvoteCreate2.default,{options:function options(_ref4){var issuesListQueryVariables=_ref4.issuesListQueryVariables,issueId=_ref4.item.id;return{optimisticResponse:createIssueUpvoteOptimisticResponse,update:function update(store,_ref5){var createIssueUpvote=_ref5.data.createIssueUpvote;var data=store.readQuery({query:_IssuesList2.default,variables:issuesListQueryVariables});var updatedData=_extends({},data,{issues:data.issues.map(function(issue){return issue.id===issueId?_extends({},issue,{allUpvotesMeta:_extends({},issue.allUpvotesMeta,{count:issue.allUpvotesMeta.count+1}),endUserUpvotes:[{id:createIssueUpvote.id,issueId:issueId,__typename:'IssueUpvote'}]}):issue;})});store.writeQuery({data:updatedData,query:_IssuesList2.default,variables:issuesListQueryVariables});}};},props:function props(_ref6){var mutate=_ref6.mutate,_ref6$ownProps=_ref6.ownProps,endUserId=_ref6$ownProps.endUserId,id=_ref6$ownProps.item.id;return{createIssueUpvote:function createIssueUpvote(){return mutate({variables:{endUserId:endUserId,issueId:id}});}};}}),(0,_reactApollo.graphql)(_IssueUpvoteDelete2.default,{options:function options(_ref7){var issuesListQueryVariables=_ref7.issuesListQueryVariables,issueId=_ref7.item.id;return{optimisticResponse:deleteIssueUpvoteOptimisticResponse,update:function update(store){var data=store.readQuery({query:_IssuesList2.default,variables:issuesListQueryVariables});var updatedData=_extends({},data,{issues:data.issues.map(function(issue){return issue.id===issueId?_extends({},issue,{allUpvotesMeta:_extends({},issue.allUpvotesMeta,{count:issue.allUpvotesMeta.count-1}),endUserUpvotes:[]}):issue;})});store.writeQuery({data:updatedData,query:_IssuesList2.default,variables:issuesListQueryVariables});}};},props:function props(_ref8){var mutate=_ref8.mutate,endUserUpvotes=_ref8.ownProps.item.endUserUpvotes;return{deleteIssueUpvote:function deleteIssueUpvote(){var _ref2;var issueUpvoteId=(_ref2=(0,_lodash.head)(endUserUpvotes))!=null?_ref2.id:_ref2;if(issueUpvoteId!==optimisticResponseId){mutate({variables:{id:issueUpvoteId}});}}};}}),(0,_recompose.withProps)(function(_ref9){var endUserUpvotes=_ref9.item.endUserUpvotes;return{upvoteSelected:!!(0,_lodash.size)(endUserUpvotes)};}),(0,_recompose.withProps)(function(_ref10){var createIssueUpvote=_ref10.createIssueUpvote,deleteIssueUpvote=_ref10.deleteIssueUpvote,upvoteSelected=_ref10.upvoteSelected;return{onPressUpvote:upvoteSelected?deleteIssueUpvote:createIssueUpvote};}));exports.default=enhance(function(_ref11){var _ref11$item=_ref11.item,totalUpvotes=_ref11$item.allUpvotesMeta.count,developerIssueDescription=_ref11$item.developerIssueDescription,developerIssueTitle=_ref11$item.developerIssueTitle,endUserIssueTitle=_ref11$item.endUserIssueTitle,endUserIssueDescription=_ref11$item.endUserIssueDescription,onPressUpvote=_ref11.onPressUpvote,upvoteSelected=_ref11.upvoteSelected;return _react2.default.createElement(_IssuesListItem2.default,{description:developerIssueDescription||endUserIssueDescription,onPressUpvote:onPressUpvote,title:developerIssueTitle||endUserIssueTitle,totalUpvotes:totalUpvotes,upvoteSelected:upvoteSelected,__source:{fileName:_jsxFileName,lineNumber:176}});});